Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class ValueOf

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.SimpleNodeConstructor
                  net.sf.saxon.instruct.ValueOf

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public final class ValueOf
extends SimpleNodeConstructor

An xsl:value-of element in the stylesheet.
The xsl:value-of element takes attributes:

- a mandatory attribute select="expression". This must be a valid String expression
- an optional disable-output-escaping attribute, value "yes" or "no"
- an optional separator attribute. This is handled at compile-time: if the separator attribute is present, the select expression passed in here will be a call to the string-join() function.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.instruct.SimpleNodeConstructor
`select`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ValueOf(Expression select, boolean disable)`

Method Summary
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check statically that the results of the expression are capable of constructing the content of a given schema type.
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Display this instruction as an expression, for diagnostics
`Item` | `evaluateItem(XPathContext context)` Evaluate as an expression.
`int` | `getCardinality()` Determine the static cardinality of the expression.
`int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
`ItemType` | `getItemType()` Get the item type of the items returned by evaluating this instruction
`TailCall` | `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
`protected void` | `promoteInst(PromotionOffer offer)` Offer promotion for subexpressions.
`void` | `setIsNumberingInstruction()` Indicate that this is really an xsl:nunber instruction
`void` | `typeCheck(StaticContext env, ItemType contextItemType)`

Methods inherited from class net.sf.saxon.instruct.SimpleNodeConstructor
`analyze, checkContent, computeSpecialProperties, createsNewNodes, evaluateNameCode, expandChildren, iterate, iterateSubExpressions, setSelect, simplify`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, getImplementationMethod, getInstructionInfo, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, computeDependencies, computeStaticProperties, dynamicError, dynamicError, getColumnNumber, getConstructType, getDependencies, getExecutable, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### ValueOf

    public ValueOf(Expression select,
                   boolean disable)

Method Detail

### setIsNumberingInstruction

    public void setIsNumberingInstruction()

  Indicate that this is really an xsl:nunber instruction

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes

  Overrides:
    `getInstructionNameCode` in class `Instruction`

### promoteInst

    protected void promoteInst(PromotionOffer offer)
                        throws XPathException

  Offer promotion for subexpressions. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Overrides:
    `promoteInst` in class `SimpleNodeConstructor`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### getItemType

    public ItemType getItemType()

  Description copied from class: `Instruction`
  Get the item type of the items returned by evaluating this instruction

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Instruction`
  Returns:
    the static item type of the instruction

### getCardinality

    public int getCardinality()

  Description copied from class: `ComputedExpression`
  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `ComputedExpression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### typeCheck

    public void typeCheck(StaticContext env,
                          ItemType contextItemType)

  Specified by:
    `typeCheck` in class `SimpleNodeConstructor`

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check statically that the results of the expression are capable of constructing the content of a given schema type.

  Specified by:
    `checkPermittedContents` in interface `Expression`
  Overrides:
    `checkPermittedContents` in class `ComputedExpression`
  Parameters:
    `parentType` - The schema type
    `env` - the static context
    `whole` -
  Throws:
    `XPathException` - if the expression doesn't match the required content type

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Description copied from class: `Instruction`
  ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.

  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
  Returns:
    null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
  Throws:
    `XPathException`

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Description copied from class: `SimpleNodeConstructor`
  Evaluate as an expression. We rely on the fact that when these instructions are generated by XQuery, there will always be a valueExpression to evaluate the content

  Specified by:
    `evaluateItem` in interface `Expression`
  Overrides:
    `evaluateItem` in class `SimpleNodeConstructor`
  Throws:
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Display this instruction as an expression, for diagnostics

  Specified by:
    `display` in interface `Expression`
  Overrides:
    `display` in class `SimpleNodeConstructor`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD